<?php

/*
Copyright (c) 2022, Michael Seevogel
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.
    * Neither the name of ISPConfig nor the names of its contributors
      may be used to endorse or promote products derived from this software without
      specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

class validate_statsdb_retention {

        function get_error($errmsg) {
		global $app;

		if(isset($app->tform->wordbook[$errmsg])) {
			return $app->tform->wordbook[$errmsg]."<br>\r\n";
		} else {
			return $errmsg."<br>\r\n";
		}
	}

        function check_statsdb_value($field_name, $field_value, $validator) {

                global $app;
        
                $limit_statsdb_retention = null;

                if(!$app->auth->is_admin()) {
                        $client_group_id = $_SESSION["s"]["user"]["default_group"];
                        $client = $app->db->queryOneRecord("SELECT limit_statsdb_retention FROM sys_group, client WHERE sys_group.client_id = client.client_id and sys_group.groupid = ?", $client_group_id);

                        $retention_value = $_POST['statsdb_retention'];

                        if($client['limit_statsdb_retention'] > 0 && $retention_value > $client['limit_statsdb_retention'] || $retention_value <= 0)  {
                                $limit_statsdb_retention_min = 1;
                                $limit_statsdb_retention_max = $client['limit_statsdb_retention'];
                                $lng_text = $this->get_error($validator['errmsg']);
                                $lng_text = str_replace(array('{minimum}', '{maximum}'), array($app->lng($limit_statsdb_retention_min), $app->lng($limit_statsdb_retention_max)), $lng_text);
                                return $lng_text;
                                
                        } else {
                                return false;
                        }
                        
                }

                if(!preg_match('/^(0|[1-9][0-9]?[0-9]?[0-9]?)$/', $field_value)) {
                        $limit_statsdb_retention_min = 0;
                        $limit_statsdb_retention_max = 9999;
                        $lng_text = $this->get_error($validator['errmsg']);
                        $lng_text = str_replace(array('{minimum}', '{maximum}'), array($app->lng($limit_statsdb_retention_min), $app->lng($limit_statsdb_retention_max)), $lng_text);
                        return $lng_text;
                } else {
                        return false;
                }
        }
  

}

